  /* These machine-generated functions compute a quartet of (fs||ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_f0d0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (twoo2z)*I1[0] - (twoo4zn)*I4[0] - (twoo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (twoo2z)*I1[1] - (twoo4zn)*I4[1] - (oneo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (twoo2z)*I1[2] - (twoo4zn)*I4[2] - (oneo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (twoo2z)*I1[3] - (twoo4zn)*I4[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (twoo2z)*I1[4] - (twoo4zn)*I4[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (twoo2z)*I1[5] - (twoo4zn)*I4[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6] - (twoo4zn)*I5[3];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (oneo2z)*I1[10] - (oneo4zn)*I4[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (oneo2z)*I1[11] - (oneo4zn)*I4[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (oneo2z)*I1[12] - (oneo4zn)*I4[12] - (twoo4zn)*I5[6];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (oneo2z)*I1[13] - (oneo4zn)*I4[13] - (oneo4zn)*I5[7];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (oneo2z)*I1[14] - (oneo4zn)*I4[14] - (oneo4zn)*I5[8];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (oneo2z)*I1[15] - (oneo4zn)*I4[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (oneo2z)*I1[16] - (oneo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (oneo2z)*I1[17] - (oneo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18] - (twoo4zn)*I5[9];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24] - (twoo4zn)*I5[12];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25] - (oneo4zn)*I5[13];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26] - (oneo4zn)*I5[14];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30] - (twoo4zn)*I5[15];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35];
*(vp++) = U01*I0[18] - U11*I3[18] + loo2p*I2[36]
        + (twoo2z)*I1[6] - (twoo4zn)*I4[6];
*(vp++) = U01*I0[19] - U11*I3[19] + loo2p*I2[37]
        + (twoo2z)*I1[7] - (twoo4zn)*I4[7] - (oneo4zn)*I5[9];
*(vp++) = U01*I0[20] - U11*I3[20] + loo2p*I2[38]
        + (twoo2z)*I1[8] - (twoo4zn)*I4[8];
*(vp++) = U01*I0[21] - U11*I3[21] + loo2p*I2[39]
        + (twoo2z)*I1[9] - (twoo4zn)*I4[9] - (twoo4zn)*I5[10];
*(vp++) = U01*I0[22] - U11*I3[22] + loo2p*I2[40]
        + (twoo2z)*I1[10] - (twoo4zn)*I4[10] - (oneo4zn)*I5[11];
*(vp++) = U01*I0[23] - U11*I3[23] + loo2p*I2[41]
        + (twoo2z)*I1[11] - (twoo4zn)*I4[11];
*(vp++) = U01*I0[24] - U11*I3[24] + loo2p*I2[42]
        + (oneo2z)*I1[12] - (oneo4zn)*I4[12];
*(vp++) = U01*I0[25] - U11*I3[25] + loo2p*I2[43]
        + (oneo2z)*I1[13] - (oneo4zn)*I4[13] - (oneo4zn)*I5[12];
*(vp++) = U01*I0[26] - U11*I3[26] + loo2p*I2[44]
        + (oneo2z)*I1[14] - (oneo4zn)*I4[14];
*(vp++) = U01*I0[27] - U11*I3[27] + loo2p*I2[45]
        + (oneo2z)*I1[15] - (oneo4zn)*I4[15] - (twoo4zn)*I5[13];
*(vp++) = U01*I0[28] - U11*I3[28] + loo2p*I2[46]
        + (oneo2z)*I1[16] - (oneo4zn)*I4[16] - (oneo4zn)*I5[14];
*(vp++) = U01*I0[29] - U11*I3[29] + loo2p*I2[47]
        + (oneo2z)*I1[17] - (oneo4zn)*I4[17];
*(vp++) = U01*I0[30] - U11*I3[30] + loo2p*I2[48];
*(vp++) = U01*I0[31] - U11*I3[31] + loo2p*I2[49] - (oneo4zn)*I5[15];
*(vp++) = U01*I0[32] - U11*I3[32] + loo2p*I2[50];
*(vp++) = U01*I0[33] - U11*I3[33] + loo2p*I2[51] - (twoo4zn)*I5[16];
*(vp++) = U01*I0[34] - U11*I3[34] + loo2p*I2[52] - (oneo4zn)*I5[17];
*(vp++) = U01*I0[35] - U11*I3[35] + loo2p*I2[53];
*(vp++) = U02*I0[30] - U12*I3[30] + loo2p*I2[54]
        + (twoo2z)*I1[12] - (twoo4zn)*I4[12];
*(vp++) = U02*I0[31] - U12*I3[31] + loo2p*I2[55]
        + (twoo2z)*I1[13] - (twoo4zn)*I4[13];
*(vp++) = U02*I0[32] - U12*I3[32] + loo2p*I2[56]
        + (twoo2z)*I1[14] - (twoo4zn)*I4[14] - (oneo4zn)*I5[15];
*(vp++) = U02*I0[33] - U12*I3[33] + loo2p*I2[57]
        + (twoo2z)*I1[15] - (twoo4zn)*I4[15];
*(vp++) = U02*I0[34] - U12*I3[34] + loo2p*I2[58]
        + (twoo2z)*I1[16] - (twoo4zn)*I4[16] - (oneo4zn)*I5[16];
*(vp++) = U02*I0[35] - U12*I3[35] + loo2p*I2[59]
        + (twoo2z)*I1[17] - (twoo4zn)*I4[17] - (twoo4zn)*I5[17];

}
