  /* This machine-generated function computes a quartet of (df|[r12,T1] integrals */

#include<libint/libint.h>

void t1hrr1_build_df(REALTYPE *AB, REALTYPE *AC, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, int lc, int ld)
{
  int cd, cd_num, c_num, cp1_num, d_num;
  int pc, qc, d, ind_c, ind_cp1d;
  const REALTYPE *i0, *i1, *i2, *i3, *i4;
  const REALTYPE AB0 = AB[0];
  const REALTYPE AB1 = AB[1];
  const REALTYPE AB2 = AB[2];
  const REALTYPE AC0 = AC[0];
  const REALTYPE AC1 = AC[1];
  const REALTYPE AC2 = AC[2];
  static int io[] = { 1, 3, 6, 10, 15, 21, 28, 36};

  c_num = io[lc];
  cp1_num = io[lc+1];
  d_num = io[ld];

  i0 = I0;
  i2 = I2;
  i1 = I1;
  i3 = I3;
  i4 = I4;
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 1*(c_num*d_num);
  i2 = I2 + 1*(c_num*d_num);
  i1 = I1 + 1*(c_num*d_num);
  i4 = I4 + 1*(c_num*d_num);
  i3 = I3 + 1*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 2*(c_num*d_num);
  i2 = I2 + 2*(c_num*d_num);
  i1 = I1 + 2*(c_num*d_num);
  i4 = I4 + 2*(c_num*d_num);
  i3 = I3 + 2*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 3*(c_num*d_num);
  i2 = I2 + 3*(c_num*d_num);
  i1 = I1 + 3*(c_num*d_num);
  i4 = I4 + 3*(c_num*d_num);
  i3 = I3 + 3*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 4*(c_num*d_num);
  i2 = I2 + 4*(c_num*d_num);
  i1 = I1 + 4*(c_num*d_num);
  i4 = I4 + 4*(c_num*d_num);
  i3 = I3 + 4*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 5*(c_num*d_num);
  i2 = I2 + 5*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 9*(c_num*d_num);
  i2 = I2 + 9*(c_num*d_num);
  i1 = I1 + 3*(c_num*d_num);
  i4 = I4 + 3*(c_num*d_num);
  i3 = I3 + 3*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 10*(c_num*d_num);
  i2 = I2 + 10*(c_num*d_num);
  i1 = I1 + 4*(c_num*d_num);
  i4 = I4 + 4*(c_num*d_num);
  i3 = I3 + 4*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 11*(c_num*d_num);
  i2 = I2 + 11*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 17*(c_num*d_num);
  i2 = I2 + 17*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 6*(c_num*d_num);
  i2 = I2 + 6*(c_num*d_num);
  i1 = I1 + 6*(c_num*d_num);
  i4 = I4 + 6*(c_num*d_num);
  i3 = I3 + 6*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 7*(c_num*d_num);
  i2 = I2 + 7*(c_num*d_num);
  i1 = I1 + 7*(c_num*d_num);
  i4 = I4 + 7*(c_num*d_num);
  i3 = I3 + 7*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 8*(c_num*d_num);
  i2 = I2 + 8*(c_num*d_num);
  i1 = I1 + 8*(c_num*d_num);
  i4 = I4 + 8*(c_num*d_num);
  i3 = I3 + 8*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 9*(c_num*d_num);
  i2 = I2 + 9*(c_num*d_num);
  i1 = I1 + 9*(c_num*d_num);
  i4 = I4 + 9*(c_num*d_num);
  i3 = I3 + 9*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 10*(c_num*d_num);
  i2 = I2 + 10*(c_num*d_num);
  i1 = I1 + 10*(c_num*d_num);
  i4 = I4 + 10*(c_num*d_num);
  i3 = I3 + 10*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 11*(c_num*d_num);
  i2 = I2 + 11*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 21*(c_num*d_num);
  i2 = I2 + 21*(c_num*d_num);
  i1 = I1 + 9*(c_num*d_num);
  i4 = I4 + 9*(c_num*d_num);
  i3 = I3 + 9*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 22*(c_num*d_num);
  i2 = I2 + 22*(c_num*d_num);
  i1 = I1 + 10*(c_num*d_num);
  i4 = I4 + 10*(c_num*d_num);
  i3 = I3 + 10*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 23*(c_num*d_num);
  i2 = I2 + 23*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 12*(c_num*d_num);
  i2 = I2 + 12*(c_num*d_num);
  i1 = I1 + 12*(c_num*d_num);
  i4 = I4 + 12*(c_num*d_num);
  i3 = I3 + 12*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 13*(c_num*d_num);
  i2 = I2 + 13*(c_num*d_num);
  i1 = I1 + 13*(c_num*d_num);
  i4 = I4 + 13*(c_num*d_num);
  i3 = I3 + 13*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 14*(c_num*d_num);
  i2 = I2 + 14*(c_num*d_num);
  i1 = I1 + 14*(c_num*d_num);
  i4 = I4 + 14*(c_num*d_num);
  i3 = I3 + 14*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 15*(c_num*d_num);
  i2 = I2 + 15*(c_num*d_num);
  i1 = I1 + 15*(c_num*d_num);
  i4 = I4 + 15*(c_num*d_num);
  i3 = I3 + 15*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 16*(c_num*d_num);
  i2 = I2 + 16*(c_num*d_num);
  i1 = I1 + 16*(c_num*d_num);
  i4 = I4 + 16*(c_num*d_num);
  i3 = I3 + 16*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 17*(c_num*d_num);
  i2 = I2 + 17*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 27*(c_num*d_num);
  i2 = I2 + 27*(c_num*d_num);
  i1 = I1 + 15*(c_num*d_num);
  i4 = I4 + 15*(c_num*d_num);
  i3 = I3 + 15*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 28*(c_num*d_num);
  i2 = I2 + 28*(c_num*d_num);
  i1 = I1 + 16*(c_num*d_num);
  i4 = I4 + 16*(c_num*d_num);
  i3 = I3 + 16*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 35*(c_num*d_num);
  i2 = I2 + 35*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 18*(c_num*d_num);
  i2 = I2 + 18*(c_num*d_num);
  i1 = I1 + 18*(c_num*d_num);
  i4 = I4 + 18*(c_num*d_num);
  i3 = I3 + 18*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 19*(c_num*d_num);
  i2 = I2 + 19*(c_num*d_num);
  i1 = I1 + 19*(c_num*d_num);
  i4 = I4 + 19*(c_num*d_num);
  i3 = I3 + 19*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 20*(c_num*d_num);
  i2 = I2 + 20*(c_num*d_num);
  i1 = I1 + 20*(c_num*d_num);
  i4 = I4 + 20*(c_num*d_num);
  i3 = I3 + 20*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 21*(c_num*d_num);
  i2 = I2 + 21*(c_num*d_num);
  i1 = I1 + 21*(c_num*d_num);
  i4 = I4 + 21*(c_num*d_num);
  i3 = I3 + 21*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 22*(c_num*d_num);
  i2 = I2 + 22*(c_num*d_num);
  i1 = I1 + 22*(c_num*d_num);
  i4 = I4 + 22*(c_num*d_num);
  i3 = I3 + 22*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 23*(c_num*d_num);
  i2 = I2 + 23*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 39*(c_num*d_num);
  i2 = I2 + 39*(c_num*d_num);
  i1 = I1 + 21*(c_num*d_num);
  i4 = I4 + 21*(c_num*d_num);
  i3 = I3 + 21*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 40*(c_num*d_num);
  i2 = I2 + 40*(c_num*d_num);
  i1 = I1 + 22*(c_num*d_num);
  i4 = I4 + 22*(c_num*d_num);
  i3 = I3 + 22*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 41*(c_num*d_num);
  i2 = I2 + 41*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 47*(c_num*d_num);
  i2 = I2 + 47*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 24*(c_num*d_num);
  i2 = I2 + 24*(c_num*d_num);
  i1 = I1 + 24*(c_num*d_num);
  i4 = I4 + 24*(c_num*d_num);
  i3 = I3 + 24*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 25*(c_num*d_num);
  i2 = I2 + 25*(c_num*d_num);
  i1 = I1 + 25*(c_num*d_num);
  i4 = I4 + 25*(c_num*d_num);
  i3 = I3 + 25*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 26*(c_num*d_num);
  i2 = I2 + 26*(c_num*d_num);
  i1 = I1 + 26*(c_num*d_num);
  i4 = I4 + 26*(c_num*d_num);
  i3 = I3 + 26*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 27*(c_num*d_num);
  i2 = I2 + 27*(c_num*d_num);
  i1 = I1 + 27*(c_num*d_num);
  i4 = I4 + 27*(c_num*d_num);
  i3 = I3 + 27*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 28*(c_num*d_num);
  i2 = I2 + 28*(c_num*d_num);
  i1 = I1 + 28*(c_num*d_num);
  i4 = I4 + 28*(c_num*d_num);
  i3 = I3 + 28*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 45*(c_num*d_num);
  i2 = I2 + 45*(c_num*d_num);
  i1 = I1 + 27*(c_num*d_num);
  i4 = I4 + 27*(c_num*d_num);
  i3 = I3 + 27*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 46*(c_num*d_num);
  i2 = I2 + 46*(c_num*d_num);
  i1 = I1 + 28*(c_num*d_num);
  i4 = I4 + 28*(c_num*d_num);
  i3 = I3 + 28*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 47*(c_num*d_num);
  i2 = I2 + 47*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 53*(c_num*d_num);
  i2 = I2 + 53*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 30*(c_num*d_num);
  i2 = I2 + 30*(c_num*d_num);
  i1 = I1 + 30*(c_num*d_num);
  i4 = I4 + 30*(c_num*d_num);
  i3 = I3 + 30*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 31*(c_num*d_num);
  i2 = I2 + 31*(c_num*d_num);
  i1 = I1 + 31*(c_num*d_num);
  i4 = I4 + 31*(c_num*d_num);
  i3 = I3 + 31*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 32*(c_num*d_num);
  i2 = I2 + 32*(c_num*d_num);
  i1 = I1 + 32*(c_num*d_num);
  i4 = I4 + 32*(c_num*d_num);
  i3 = I3 + 32*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 33*(c_num*d_num);
  i2 = I2 + 33*(c_num*d_num);
  i1 = I1 + 33*(c_num*d_num);
  i4 = I4 + 33*(c_num*d_num);
  i3 = I3 + 33*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 34*(c_num*d_num);
  i2 = I2 + 34*(c_num*d_num);
  i1 = I1 + 34*(c_num*d_num);
  i4 = I4 + 34*(c_num*d_num);
  i3 = I3 + 34*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 35*(c_num*d_num);
  i2 = I2 + 35*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 51*(c_num*d_num);
  i2 = I2 + 51*(c_num*d_num);
  i1 = I1 + 33*(c_num*d_num);
  i4 = I4 + 33*(c_num*d_num);
  i3 = I3 + 33*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 52*(c_num*d_num);
  i2 = I2 + 52*(c_num*d_num);
  i1 = I1 + 34*(c_num*d_num);
  i4 = I4 + 34*(c_num*d_num);
  i3 = I3 + 34*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 53*(c_num*d_num);
  i2 = I2 + 53*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 59*(c_num*d_num);
  i2 = I2 + 59*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

}
