  /* These machine-generated functions compute a quartet of (ps|[r12,T2]|ps) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_p0p0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezdon;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezdon = 1.0*(Data->twozeta_d*Data->oo2n);
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 2.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[3])
          - U12*(I1[2] - I2[6])
          + (onezdon)*(I3[0] + AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[3] - I2[4])
          - U12*(I1[4] - I2[7])
          + (onezdon)*(I3[1] + AC1*I4[0]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[4] - I2[5])
          - U12*(I1[5] - I2[8])
          + (onezdon)*(I3[2] + AC2*I4[0]);
*(vp++) = U0*I0[3]
          - U10*(I1[6] - I2[3])
          - U11*(I1[7] - I2[9])
          - U12*(I1[8] - I2[12])
          + (onezdon)*(I3[1] + AC0*I4[1]);
*(vp++) = U0*I0[4]
          - U10*(I1[7] - I2[4])
          - U11*(I1[9] - I2[10])
          - U12*(I1[10] - I2[13])
          + (onezdon)*(I3[3] + AC1*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[8] - I2[5])
          - U11*(I1[10] - I2[11])
          - U12*(I1[11] - I2[14])
          + (onezdon)*(I3[4] + AC2*I4[1]);
*(vp++) = U0*I0[6]
          - U10*(I1[12] - I2[6])
          - U11*(I1[13] - I2[12])
          - U12*(I1[14] - I2[15])
          + (onezdon)*(I3[2] + AC0*I4[2]);
*(vp++) = U0*I0[7]
          - U10*(I1[13] - I2[7])
          - U11*(I1[15] - I2[13])
          - U12*(I1[16] - I2[16])
          + (onezdon)*(I3[4] + AC1*I4[2]);
*(vp++) = U0*I0[8]
          - U10*(I1[14] - I2[8])
          - U11*(I1[16] - I2[14])
          - U12*(I1[17] - I2[17])
          + (onezdon)*(I3[5] + AC2*I4[2]);

}
