  /* This machine-generated function computes a quartet of [r12,T2]|pp) integrals */

#include<libint/libint.h>

void t2hrr3_build_pp(REALTYPE *CD, REALTYPE *AC, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, int la, int lb)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];
  const REALTYPE AC0 = AC[0];
  const REALTYPE AC1 = AC[1];
  const REALTYPE AC2 = AC[2];
  static int io[] = { 1, 3, 6, 10, 15, 21, 28, 36};
  int bcdm1_num = io[lb]*3;

  int pa, qa, b;
  for(pa=0;pa<=la;pa++)
    for(qa=0;qa<=pa;qa++)
      for(b=0;b<((lb+1)*(lb+2)/2);b++) {
        *(vp++) = I0[0] + CD0*I1[0] + I2[0] - AC0*I4[0] - I3[0];
        *(vp++) = I0[1] + CD1*I1[0] + I2[1] - AC1*I4[0] - I3[(pa+1)*bcdm1_num+0];
        *(vp++) = I0[2] + CD2*I1[0] + I2[2] - AC2*I4[0] - I3[(pa+2)*bcdm1_num+0];
        *(vp++) = I0[1] + CD0*I1[1] + I2[1] - AC0*I4[1] - I3[1];
        *(vp++) = I0[3] + CD1*I1[1] + I2[3] - AC1*I4[1] - I3[(pa+1)*bcdm1_num+1];
        *(vp++) = I0[4] + CD2*I1[1] + I2[4] - AC2*I4[1] - I3[(pa+2)*bcdm1_num+1];
        *(vp++) = I0[2] + CD0*I1[2] + I2[2] - AC0*I4[2] - I3[2];
        *(vp++) = I0[4] + CD1*I1[2] + I2[4] - AC1*I4[2] - I3[(pa+1)*bcdm1_num+2];
        *(vp++) = I0[5] + CD2*I1[2] + I2[5] - AC2*I4[2] - I3[(pa+2)*bcdm1_num+2];
        I0 += 6;
        I1 += 3;
        I2 += 6;
        I3 += 3;
        I4 += 3;
  }
}
