  /* These machine-generated functions compute a quartet of (0s||ps) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_00p0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  U20 = Data->U[2][0];
  U21 = Data->U[2][1];
  U22 = Data->U[2][2];
  U10 = Data->U[2][0]*Data->oo2z + Data->U[3][0]*Data->oo2n;
  U11 = Data->U[2][1]*Data->oo2z + Data->U[3][1]*Data->oo2n;
  U12 = Data->U[2][2]*Data->oo2z + Data->U[3][2]*Data->oo2n;

*(vp++) = U20*I0[0] - U10*I3[0] + loo2p*I2[0];
*(vp++) = U21*I0[0] - U11*I3[0] + loo2p*I2[1];
*(vp++) = U22*I0[0] - U12*I3[0] + loo2p*I2[2];

}
