  /* These machine-generated functions compute a quartet of (ps||fs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_p0f0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0] - (threeo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1] - (twoo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2] - (twoo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3] - (oneo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9];
*(vp++) = U01*I0[0] - U11*I3[0] + loo2p*I2[10];
*(vp++) = U01*I0[1] - U11*I3[1] + loo2p*I2[11] - (oneo4zn)*I5[0];
*(vp++) = U01*I0[2] - U11*I3[2] + loo2p*I2[12];
*(vp++) = U01*I0[3] - U11*I3[3] + loo2p*I2[13] - (twoo4zn)*I5[1];
*(vp++) = U01*I0[4] - U11*I3[4] + loo2p*I2[14] - (oneo4zn)*I5[2];
*(vp++) = U01*I0[5] - U11*I3[5] + loo2p*I2[15];
*(vp++) = U01*I0[6] - U11*I3[6] + loo2p*I2[16] - (threeo4zn)*I5[3];
*(vp++) = U01*I0[7] - U11*I3[7] + loo2p*I2[17] - (twoo4zn)*I5[4];
*(vp++) = U01*I0[8] - U11*I3[8] + loo2p*I2[18] - (oneo4zn)*I5[5];
*(vp++) = U01*I0[9] - U11*I3[9] + loo2p*I2[19];
*(vp++) = U02*I0[0] - U12*I3[0] + loo2p*I2[20];
*(vp++) = U02*I0[1] - U12*I3[1] + loo2p*I2[21];
*(vp++) = U02*I0[2] - U12*I3[2] + loo2p*I2[22] - (oneo4zn)*I5[0];
*(vp++) = U02*I0[3] - U12*I3[3] + loo2p*I2[23];
*(vp++) = U02*I0[4] - U12*I3[4] + loo2p*I2[24] - (oneo4zn)*I5[1];
*(vp++) = U02*I0[5] - U12*I3[5] + loo2p*I2[25] - (twoo4zn)*I5[2];
*(vp++) = U02*I0[6] - U12*I3[6] + loo2p*I2[26];
*(vp++) = U02*I0[7] - U12*I3[7] + loo2p*I2[27] - (oneo4zn)*I5[3];
*(vp++) = U02*I0[8] - U12*I3[8] + loo2p*I2[28] - (twoo4zn)*I5[4];
*(vp++) = U02*I0[9] - U12*I3[9] + loo2p*I2[29] - (threeo4zn)*I5[5];

}
